javax.jms

## Interface Session

- All Superinterfaces:
    java.lang.AutoCloseable, java.lang.Runnable
  All Known Subinterfaces:
    QueueSession, TopicSession, XAQueueSession, XASession, XATopicSession

      public interface Session
      extends java.lang.Runnable, java.lang.AutoCloseable

  A `Session` object is a single-threaded context for producing and consuming messages. Although it may allocate provider resources outside the Java virtual machine (JVM), it is considered a lightweight JMS object.

  A session serves several purposes:

  - It is a factory for its message producers and consumers.
  - It supplies provider-optimized message factories.
  - It is a factory for `TemporaryTopics` and `TemporaryQueues`.
  - It provides a way to create `Queue` or `Topic` objects for those clients that need to dynamically manipulate provider-specific destination names.
  - It supports a single series of transactions that combine work spanning its producers and consumers into atomic units.
  - It defines a serial order for the messages it consumes and the messages it produces.
  - It retains messages it consumes until they have been acknowledged.
  - It serializes execution of message listeners registered with its message consumers.
  - It is a factory for `QueueBrowsers`.

  A session can create and service multiple message producers and consumers.

  One typical use is to have a thread block on a synchronous `MessageConsumer` until a message arrives. The thread may then use one or more of the `Session`'s `MessageProducer`s.

  If a client desires to have one thread produce messages while others consume them, the client should use a separate session for its producing thread.

  Once a connection has been started, any session with one or more registered message listeners is dedicated to the thread of control that delivers messages to it. It is erroneous for client code to use this session or any of its constituent objects from another thread of control. The only exception to this rule is the use of the session or connection `close` method.

  It should be easy for most clients to partition their work naturally into sessions. This model allows clients to start simply and incrementally add message processing complexity as their need for concurrency grows.

  The `close` method is the only session method that can be called while some other session method is being executed in another thread.

  A session may be specified as transacted. Each transacted session supports a single series of transactions. Each transaction groups a set of message sends and a set of message receives into an atomic unit of work. In effect, transactions organize a session's input message stream and output message stream into series of atomic units. When a transaction commits, its atomic unit of input is acknowledged and its associated atomic unit of output is sent. If a transaction rollback is done, the transaction's sent messages are destroyed and the session's input is automatically recovered.

  The content of a transaction's input and output units is simply those messages that have been produced and consumed within the session's current transaction.

  A transaction is completed using either its session's `commit` method or its session's `rollback` method. The completion of a session's current transaction automatically begins the next. The result is that a transacted session always has a current transaction within which its work is done.

  The Java Transaction Service (JTS) or some other transaction monitor may be used to combine a session's transaction with transactions on other resources (databases, other JMS sessions, etc.). Since Java distributed transactions are controlled via the Java Transaction API (JTA), use of the session's `commit` and `rollback` methods in this context is prohibited.

  The JMS API does not require support for JTA; however, it does define how a provider supplies this support.

  Although it is also possible for a JMS client to handle distributed transactions directly, it is unlikely that many JMS clients will do this. Support for JTA in the JMS API is targeted at systems vendors who will be integrating the JMS API into their application server products.

  Since:
    JMS 1.0
  See Also:
    `QueueSession`, `TopicSession`, `XASession`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `AUTO_ACKNOWLEDGE` With this acknowledgment mode, the session automatically acknowledges a client's receipt of a message either when the session has successfully returned from a call to `receive` or when the message listener the session has called to process the message successfully returns.
    `static int` | `CLIENT_ACKNOWLEDGE` With this acknowledgment mode, the client acknowledges a consumed message by calling the message's `acknowledge` method.
    `static int` | `DUPS_OK_ACKNOWLEDGE` This acknowledgment mode instructs the session to lazily acknowledge the delivery of messages.
    `static int` | `SESSION_TRANSACTED` This value may be passed as the argument to the method `createSession(int sessionMode)` on the `Connection` object to specify that the session should use a local transaction.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the session.
    `void` | `commit()` Commits all messages done in this transaction and releases any locks currently held.
    `QueueBrowser` | `createBrowser(Queue queue)` Creates a `QueueBrowser` object to peek at the messages on the specified queue.
    `QueueBrowser` | `createBrowser(Queue queue, java.lang.String messageSelector)` Creates a `QueueBrowser` object to peek at the messages on the specified queue using a message selector.
    `BytesMessage` | `createBytesMessage()` Creates a `BytesMessage` object.
    `MessageConsumer` | `createConsumer(Destination destination)` Creates a `MessageConsumer` for the specified destination.
    `MessageConsumer` | `createConsumer(Destination destination, java.lang.String messageSelector)` Creates a `MessageConsumer` for the specified destination, using a message selector.
    `MessageConsumer` | `createConsumer(Destination destination, java.lang.String messageSelector, boolean noLocal)` Creates a `MessageConsumer` for the specified destination, specifying a message selector and the `noLocal` parameter.
    `MessageConsumer` | `createDurableConsumer(Topic topic, java.lang.String name)` Creates an unshared durable subscription on the specified topic (if one does not already exist) and creates a consumer on that durable subscription.
    `MessageConsumer` | `createDurableConsumer(Topic topic, java.lang.String name, java.lang.String messageSelector, boolean noLocal)` Creates an unshared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.
    `TopicSubscriber` | `createDurableSubscriber(Topic topic, java.lang.String name)` Creates an unshared durable subscription on the specified topic (if one does not already exist) and creates a consumer on that durable subscription.
    `TopicSubscriber` | `createDurableSubscriber(Topic topic, java.lang.String name, java.lang.String messageSelector, boolean noLocal)` Creates an unshared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.
    `MapMessage` | `createMapMessage()` Creates a `MapMessage` object.
    `Message` | `createMessage()` Creates a `Message` object.
    `ObjectMessage` | `createObjectMessage()` Creates an `ObjectMessage` object.
    `ObjectMessage` | `createObjectMessage(java.io.Serializable object)` Creates an initialized `ObjectMessage` object.
    `MessageProducer` | `createProducer(Destination destination)` Creates a `MessageProducer` to send messages to the specified destination.
    `Queue` | `createQueue(java.lang.String queueName)` Creates a `Queue` object which encapsulates a specified provider-specific queue name.
    `MessageConsumer` | `createSharedConsumer(Topic topic, java.lang.String sharedSubscriptionName)` Creates a shared non-durable subscription with the specified name on the specified topic (if one does not already exist) and creates a consumer on that subscription.
    `MessageConsumer` | `createSharedConsumer(Topic topic, java.lang.String sharedSubscriptionName, java.lang.String messageSelector)` Creates a shared non-durable subscription with the specified name on the specified topic (if one does not already exist) specifying a message selector, and creates a consumer on that subscription.
    `MessageConsumer` | `createSharedDurableConsumer(Topic topic, java.lang.String name)` Creates a shared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.
    `MessageConsumer` | `createSharedDurableConsumer(Topic topic, java.lang.String name, java.lang.String messageSelector)` Creates a shared durable subscription on the specified topic (if one does not already exist), specifying a message selector, and creates a consumer on that durable subscription.
    `StreamMessage` | `createStreamMessage()` Creates a `StreamMessage` object.
    `TemporaryQueue` | `createTemporaryQueue()` Creates a `TemporaryQueue` object.
    `TemporaryTopic` | `createTemporaryTopic()` Creates a `TemporaryTopic` object.
    `TextMessage` | `createTextMessage()` Creates a `TextMessage` object.
    `TextMessage` | `createTextMessage(java.lang.String text)` Creates an initialized `TextMessage` object.
    `Topic` | `createTopic(java.lang.String topicName)` Creates a `Topic` object which encapsulates a specified provider-specific topic name.
    `int` | `getAcknowledgeMode()` Returns the acknowledgement mode of the session.
    `MessageListener` | `getMessageListener()` Returns the session's distinguished message listener (optional).
    `boolean` | `getTransacted()` Indicates whether the session is in transacted mode.
    `void` | `recover()` Stops message delivery in this session, and restarts message delivery with the oldest unacknowledged message.
    `void` | `rollback()` Rolls back any messages done in this transaction and releases any locks currently held.
    `void` | `run()` Optional operation, intended to be used only by Application Servers, not by ordinary JMS clients.
    `void` | `setMessageListener(MessageListener listener)` Sets the session's distinguished message listener (optional).
    `void` | `unsubscribe(java.lang.String name)` Unsubscribes a durable subscription that has been created by a client.

- - ### Field Detail

    - #### AUTO_ACKNOWLEDGE

          static final int AUTO_ACKNOWLEDGE

      With this acknowledgment mode, the session automatically acknowledges a client's receipt of a message either when the session has successfully returned from a call to `receive` or when the message listener the session has called to process the message successfully returns.
      See Also:
        Constant Field Values

    - #### CLIENT_ACKNOWLEDGE

          static final int CLIENT_ACKNOWLEDGE

      With this acknowledgment mode, the client acknowledges a consumed message by calling the message's `acknowledge` method. Acknowledging a consumed message acknowledges all messages that the session has consumed.

      When client acknowledgment mode is used, a client may build up a large number of unacknowledged messages while attempting to process them. A JMS provider should provide administrators with a way to limit client overrun so that clients are not driven to resource exhaustion and ensuing failure when some resource they are using is temporarily blocked.

      See Also:
        `Message.acknowledge()`, Constant Field Values

    - #### DUPS_OK_ACKNOWLEDGE

          static final int DUPS_OK_ACKNOWLEDGE

      This acknowledgment mode instructs the session to lazily acknowledge the delivery of messages. This is likely to result in the delivery of some duplicate messages if the JMS provider fails, so it should only be used by consumers that can tolerate duplicate messages. Use of this mode can reduce session overhead by minimizing the work the session does to prevent duplicates.
      See Also:
        Constant Field Values

    - #### SESSION_TRANSACTED

          static final int SESSION_TRANSACTED

      This value may be passed as the argument to the method `createSession(int sessionMode)` on the `Connection` object to specify that the session should use a local transaction.

      This value is returned from the method `getAcknowledgeMode` if the session is using a local transaction, irrespective of whether the session was created by calling the method `createSession(int sessionMode)` or the method `createSession(boolean transacted, int acknowledgeMode)`.

      Since:
        JMS 1.1
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### createBytesMessage

          BytesMessage createBytesMessage()
                                   throws JMSException

      Creates a `BytesMessage` object. A `BytesMessage` object is used to send a message containing a stream of uninterpreted bytes.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createMapMessage

          MapMessage createMapMessage()
                               throws JMSException

      Creates a `MapMessage` object. A `MapMessage` object is used to send a self-defining set of name-value pairs, where names are `String` objects and values are primitive values in the Java programming language.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createMessage

          Message createMessage()
                         throws JMSException

      Creates a `Message` object. The `Message` interface is the root interface of all JMS messages. A `Message` object holds all the standard message header information. It can be sent when a message containing only header information is sufficient.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createObjectMessage

          ObjectMessage createObjectMessage()
                                     throws JMSException

      Creates an `ObjectMessage` object. An `ObjectMessage` object is used to send a message that contains a serializable Java object.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createObjectMessage

          ObjectMessage createObjectMessage(java.io.Serializable object)
                                     throws JMSException

      Creates an initialized `ObjectMessage` object. An `ObjectMessage` object is used to send a message that contains a serializable Java object.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Parameters:
        `object` - the object to use to initialize this message
      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createStreamMessage

          StreamMessage createStreamMessage()
                                     throws JMSException

      Creates a `StreamMessage` object. A `StreamMessage` object is used to send a self-defining stream of primitive values in the Java programming language.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createTextMessage

          TextMessage createTextMessage()
                                 throws JMSException

      Creates a `TextMessage` object. A `TextMessage` object is used to send a message containing a `String` object.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### createTextMessage

          TextMessage createTextMessage(java.lang.String text)
                                 throws JMSException

      Creates an initialized `TextMessage` object. A `TextMessage` object is used to send a message containing a `String`.

      The message object returned may be sent using any `Session` or `JMSContext`. It is not restricted to being sent using the `JMSContext` used to create it.

      The message object returned may be optimised for use with the JMS provider used to create it. However it can be sent using any JMS provider, not just the JMS provider used to create it.

      Parameters:
        `text` - the string used to initialize this message
      Throws:
        `JMSException` - if the JMS provider fails to create this message due to some internal error.

    - #### getTransacted

          boolean getTransacted()
                         throws JMSException

      Indicates whether the session is in transacted mode.
      Returns:
        true if the session is in transacted mode
      Throws:
        `JMSException` - if the JMS provider fails to return the transaction mode due to some internal error.

    - #### getAcknowledgeMode

          int getAcknowledgeMode()
                          throws JMSException

      Returns the acknowledgement mode of the session. The acknowledgement mode is set at the time that the session is created. If the session is transacted, the acknowledgement mode is ignored.
      Returns:
        If the session is not transacted, returns the current acknowledgement mode for the session. If the session is transacted, returns SESSION_TRANSACTED.
      Throws:
        `JMSException` - if the JMS provider fails to return the acknowledgment mode due to some internal error.
      Since:
        JMS 1.1
      See Also:
        `Connection.createSession(boolean, int)`

    - #### commit

          void commit()
               throws JMSException

      Commits all messages done in this transaction and releases any locks currently held.

      This method must not return until any incomplete asynchronous send operations for this `Session` have been completed and any `CompletionListener` callbacks have returned. Incomplete sends should be allowed to complete normally unless an error occurs.

      A `CompletionListener` callback method must not call `commit` on its own `Session`. Doing so will cause an `IllegalStateException` to be thrown.

      Throws:
        `IllegalStateException` -
        - the session is not using a local transaction
        - this method has been called by a `CompletionListener` callback method on its own `Session`
        `JMSException` - if the JMS provider fails to commit the transaction due to some internal error.
        `TransactionRolledBackException` - if the transaction is rolled back due to some internal error during commit.

    - #### rollback

          void rollback()
                 throws JMSException

      Rolls back any messages done in this transaction and releases any locks currently held.

      This method must not return until any incomplete asynchronous send operations for this `Session` have been completed and any `CompletionListener` callbacks have returned. Incomplete sends should be allowed to complete normally unless an error occurs.

      A `CompletionListener` callback method must not call `commit` on its own `Session`. Doing so will cause an `IllegalStateException` to be thrown.

      Throws:
        `IllegalStateException` -
        - the session is not using a local transaction
        - this method has been called by a `CompletionListener` callback method on its own `Session`
        `JMSException` - if the JMS provider fails to roll back the transaction due to some internal error.

    - #### close

          void close()
              throws JMSException

      Closes the session.

      Since a provider may allocate some resources on behalf of a session outside the JVM, clients should close the resources when they are not needed. Relying on garbage collection to eventually reclaim these resources may not be timely enough.

      There is no need to close the producers and consumers of a closed session.

      This call will block until a `receive` call or message listener in progress has completed. A blocked message consumer `receive` call returns `null` when this session is closed.

      This method must not return until any incomplete asynchronous send operations for this `Session` have been completed and any `CompletionListener` callbacks have returned. Incomplete sends should be allowed to complete normally unless an error occurs.

      For the avoidance of doubt, if an exception listener for this session's connection is running when `close` is invoked, there is no requirement for the `close` call to wait until the exception listener has returned before it may return.

      Closing a transacted session must roll back the transaction in progress.

      This method is the only `Session` method that can be called concurrently.

      A `MessageListener` must not attempt to close its own `Session` as this would lead to deadlock. The JMS provider must detect this and throw a `IllegalStateException`.

      A `CompletionListener` callback method must not call `close` on its own `Session`. Doing so will cause an `IllegalStateException` to be thrown.

      Invoking any other `Session` method on a closed session must throw a `IllegalStateException`. Closing a closed session must not throw an exception.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Throws:
        `IllegalStateException` -
        - this method has been called by a `MessageListener` on its own `Session`
        - this method has been called by a `CompletionListener` callback method on its own `Session`
        `JMSException` - if the JMS provider fails to close the session due to some internal error.

    - #### recover

          void recover()
                throws JMSException

      Stops message delivery in this session, and restarts message delivery with the oldest unacknowledged message.

      All consumers deliver messages in a serial order. Acknowledging a received message automatically acknowledges all messages that have been delivered to the client.

      Restarting a session causes it to take the following actions:

      - Stop message delivery
      - Mark all messages that might have been delivered but not acknowledged as "redelivered"
      - Restart the delivery sequence including all unacknowledged messages that had been previously delivered. Redelivered messages do not have to be delivered in exactly their original delivery order.
      Throws:
        `JMSException` - if the JMS provider fails to stop and restart message delivery due to some internal error.
        `IllegalStateException` - if the method is called by a transacted session.

    - #### getMessageListener

          MessageListener getMessageListener()
                                      throws JMSException

      Returns the session's distinguished message listener (optional).

      This method must not be used in a Java EE web or EJB application. Doing so may cause a `JMSException` to be thrown though this is not guaranteed.

      Returns:
        the distinguished message listener associated with this session
      Throws:
        `JMSException` - if the JMS provider fails to get the session's distinguished message listener for one of the following reasons:
        - an internal error has occurred
        - this method has been called in a Java EE web or EJB application (though it is not guaranteed that an exception is thrown in this case)
      See Also:
        `setMessageListener(javax.jms.MessageListener)`, `ServerSessionPool`, `ServerSession`

    - #### setMessageListener

          void setMessageListener(MessageListener listener)
                           throws JMSException

      Sets the session's distinguished message listener (optional).

      When the distinguished message listener is set, no other form of message receipt in the session can be used; however, all forms of sending messages are still supported.

      This is an expert facility not used by ordinary JMS clients.

      This method must not be used in a Java EE web or EJB application. Doing so may cause a `JMSException` to be thrown though this is not guaranteed.

      Parameters:
        `listener` - the message listener to associate with this session
      Throws:
        `JMSException` - if the JMS provider fails to set the session's distinguished message listener for one of the following reasons:
        - an internal error has occurred
        - this method has been called in a Java EE web or EJB application (though it is not guaranteed that an exception is thrown in this case)
      See Also:
        `getMessageListener()`, `ServerSessionPool`, `ServerSession`

    - #### run

          void run()

      Optional operation, intended to be used only by Application Servers, not by ordinary JMS clients.

      This method must not be used in a Java EE web or EJB application. Doing so may cause a `JMSRuntimeException` to be thrown though this is not guaranteed.

      Specified by:
        `run` in interface `java.lang.Runnable`
      Throws:
        `JMSRuntimeException` - if this method has been called in a Java EE web or EJB application (though it is not guaranteed that an exception is thrown in this case)
      See Also:
        `ServerSession`

    - #### createProducer

          MessageProducer createProducer(Destination destination)
                                  throws JMSException

      Creates a `MessageProducer` to send messages to the specified destination.

      A client uses a `MessageProducer` object to send messages to a destination. Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageProducer` object.

      Parameters:
        `destination` - the `Destination` to send to, or null if this is a producer which does not have a specified destination.
      Throws:
        `JMSException` - if the session fails to create a MessageProducer due to some internal error.
        `InvalidDestinationException` - if an invalid destination is specified.
      Since:
        JMS 1.1

    - #### createConsumer

          MessageConsumer createConsumer(Destination destination)
                                  throws JMSException

      Creates a `MessageConsumer` for the specified destination. Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageConsumer`.
      Parameters:
        `destination` - the `Destination` to access.
      Throws:
        `JMSException` - if the session fails to create a consumer due to some internal error.
        `InvalidDestinationException` - if an invalid destination is specified.
      Since:
        JMS 1.1

    - #### createConsumer

          MessageConsumer createConsumer(Destination destination,
                                         java.lang.String messageSelector)
                                  throws JMSException

      Creates a `MessageConsumer` for the specified destination, using a message selector. Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageConsumer`.

      A client uses a `MessageConsumer` object to receive messages that have been sent to a destination.

      Parameters:
        `destination` - the `Destination` to access
        `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
      Throws:
        `JMSException` - if the session fails to create a MessageConsumer due to some internal error.
        `InvalidDestinationException` - if an invalid destination is specified.
        `InvalidSelectorException` - if the message selector is invalid.
      Since:
        JMS 1.1

    - #### createConsumer

          MessageConsumer createConsumer(Destination destination,
                                         java.lang.String messageSelector,
                                         boolean noLocal)
                                  throws JMSException

      Creates a `MessageConsumer` for the specified destination, specifying a message selector and the `noLocal` parameter.

      Since `Queue` and `Topic` both inherit from `Destination`, they can be used in the destination parameter to create a `MessageConsumer`.

      A client uses a `MessageConsumer` object to receive messages that have been published to a destination.

      The `noLocal` argument is for use when the destination is a topic and the session's connection is also being used to publish messages to that topic. If `noLocal` is set to true then the `MessageConsumer` will not receive messages published to the topic by its own connection. The default value of this argument is false. If the destination is a queue then the effect of setting `noLocal` to true is not specified.

      Parameters:
        `destination` - the `Destination` to access
        `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
        `noLocal` - - if true, and the destination is a topic, then the `MessageConsumer` will not receive messages published to the topic by its own connection.
      Throws:
        `JMSException` - if the session fails to create a MessageConsumer due to some internal error.
        `InvalidDestinationException` - if an invalid destination is specified.
        `InvalidSelectorException` - if the message selector is invalid.
      Since:
        JMS 1.1

    - #### createSharedConsumer

          MessageConsumer createSharedConsumer(Topic topic,
                                               java.lang.String sharedSubscriptionName)
                                        throws JMSException

      Creates a shared non-durable subscription with the specified name on the specified topic (if one does not already exist) and creates a consumer on that subscription. This method creates the non-durable subscription without a message selector.

      If a shared non-durable subscription already exists with the same name and client identifier (if set), and the same topic and message selector value has been specified, then this method creates a `MessageConsumer` on the existing subscription.

      A non-durable shared subscription is used by a client which needs to be able to share the work of receiving messages from a topic subscription amongst multiple consumers. A non-durable shared subscription may therefore have more than one consumer. Each message from the subscription will be delivered to only one of the consumers on that subscription. Such a subscription is not persisted and will be deleted (together with any undelivered messages associated with it) when there are no consumers on it. The term "consumer" here means a `MessageConsumer` or `JMSConsumer` object in any client.

      A shared non-durable subscription is identified by a name specified by the client and by the client identifier (which may be unset). An application which subsequently wishes to create a consumer on that shared non-durable subscription must use the same client identifier.

      If a shared non-durable subscription already exists with the same name and client identifier (if set) but a different topic or message selector has been specified, and there is a consumer already active (i.e. not closed) on the subscription, then a `JMSException` will be thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId (which may be unset). Such subscriptions would be completely separate.

      Parameters:
        `topic` - the `Topic` to subscribe to
        `sharedSubscriptionName` - the name used to identify the shared non-durable subscription
      Throws:
        `JMSException` - if the session fails to create the shared non-durable subscription and `MessageConsumer` due to some internal error.
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.
      Since:
        JMS 2.0

    - #### createSharedConsumer

          MessageConsumer createSharedConsumer(Topic topic,
                                               java.lang.String sharedSubscriptionName,
                                               java.lang.String messageSelector)
                                        throws JMSException

      Creates a shared non-durable subscription with the specified name on the specified topic (if one does not already exist) specifying a message selector, and creates a consumer on that subscription.

      If a shared non-durable subscription already exists with the same name and client identifier (if set), and the same topic and message selector has been specified, then this method creates a `MessageConsumer` on the existing subscription.

      A non-durable shared subscription is used by a client which needs to be able to share the work of receiving messages from a topic subscription amongst multiple consumers. A non-durable shared subscription may therefore have more than one consumer. Each message from the subscription will be delivered to only one of the consumers on that subscription. Such a subscription is not persisted and will be deleted (together with any undelivered messages associated with it) when there are no consumers on it. The term "consumer" here means a `MessageConsumer` or `JMSConsumer` object in any client.

      A shared non-durable subscription is identified by a name specified by the client and by the client identifier (which may be unset). An application which subsequently wishes to create a consumer on that shared non-durable subscription must use the same client identifier.

      If a shared non-durable subscription already exists with the same name and client identifier (if set) but a different topic or message selector has been specified, and there is a consumer already active (i.e. not closed) on the subscription, then a `JMSException` will be thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId (which may be unset). Such subscriptions would be completely separate.

      Parameters:
        `topic` - the `Topic` to subscribe to
        `sharedSubscriptionName` - the name used to identify the shared non-durable subscription
        `messageSelector` - only messages with properties matching the message selector expression are added to the shared non-durable subscription. A value of null or an empty string indicates that there is no message selector for the shared non-durable subscription.
      Throws:
        `JMSException` - if the session fails to create the shared non-durable subscription and `MessageConsumer` due to some internal error.
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.
      Since:
        JMS 2.0

    - #### createQueue

          Queue createQueue(java.lang.String queueName)
                     throws JMSException

      Creates a `Queue` object which encapsulates a specified provider-specific queue name.

      The use of provider-specific queue names in an application may render the application non-portable. Portable applications are recommended to not use this method but instead look up an administratively-defined `Queue` object using JNDI.

      Note that this method simply creates an object that encapsulates the name of a queue. It does not create the physical queue in the JMS provider. JMS does not provide a method to create the physical queue, since this would be specific to a given JMS provider. Creating a physical queue is provider-specific and is typically an administrative task performed by an administrator, though some providers may create them automatically when needed. The one exception to this is the creation of a temporary queue, which is done using the `createTemporaryQueue` method.

      Parameters:
        `queueName` - A provider-specific queue name
      Returns:
        a Queue object which encapsulates the specified name
      Throws:
        `JMSException` - if a Queue object cannot be created due to some internal error

    - #### createTopic

          Topic createTopic(java.lang.String topicName)
                     throws JMSException

      Creates a `Topic` object which encapsulates a specified provider-specific topic name.

      The use of provider-specific topic names in an application may render the application non-portable. Portable applications are recommended to not use this method but instead look up an administratively-defined `Topic` object using JNDI.

      Note that this method simply creates an object that encapsulates the name of a topic. It does not create the physical topic in the JMS provider. JMS does not provide a method to create the physical topic, since this would be specific to a given JMS provider. Creating a physical topic is provider-specific and is typically an administrative task performed by an administrator, though some providers may create them automatically when needed. The one exception to this is the creation of a temporary topic, which is done using the `createTemporaryTopic` method.

      Parameters:
        `topicName` - A provider-specific topic name
      Returns:
        a Topic object which encapsulates the specified name
      Throws:
        `JMSException` - if a Topic object cannot be created due to some internal error

    - #### createDurableSubscriber

          TopicSubscriber createDurableSubscriber(Topic topic,
                                                  java.lang.String name)
                                           throws JMSException

      Creates an unshared durable subscription on the specified topic (if one does not already exist) and creates a consumer on that durable subscription. This method creates the durable subscription without a message selector and with a `noLocal` value of `false`.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with unshared durable subscriptions. Any durable subscription created using this method will be unshared. This means that only one active (i.e. not closed) consumer on the subscription may exist at a time. The term "consumer" here means a `TopicSubscriber`, `MessageConsumer` or `JMSConsumer` object in any client.

      An unshared durable subscription is identified by a name specified by the client and by the client identifier, which must be set. An application which subsequently wishes to create a consumer on that unshared durable subscription must use the same client identifier.

      If an unshared durable subscription already exists with the same name and client identifier, and the same topic, message selector and `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this method creates a `TopicSubscriber` on the existing durable subscription.

      If an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active (i.e. not closed) on the durable subscription, then a `JMSException` will be thrown.

      If an unshared durable subscription already exists with the same name and client identifier but a different topic, message selector or `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this is equivalent to unsubscribing (deleting) the old one and creating a new one.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier. If a shared durable subscription already exists with the same name and client identifier then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId. Such subscriptions would be completely separate.

      This method is identical to the corresponding `createDurableConsumer` method except that it returns a `TopicSubscriber` rather than a `MessageConsumer` to represent the consumer.

      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
      Throws:
        `InvalidDestinationException` - if an invalid topic is specified.
        `IllegalStateException` - if the client identifier is unset
        `JMSException` -
        - if the session fails to create the unshared durable subscription and `TopicSubscriber` due to some internal error
        - if an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active
        - if a shared durable subscription already exists with the same name and client identifier
      Since:
        JMS 1.1

    - #### createDurableSubscriber

          TopicSubscriber createDurableSubscriber(Topic topic,
                                                  java.lang.String name,
                                                  java.lang.String messageSelector,
                                                  boolean noLocal)
                                           throws JMSException

      Creates an unshared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with unshared durable subscriptions. Any durable subscription created using this method will be unshared. This means that only one active (i.e. not closed) consumer on the subscription may exist at a time. The term "consumer" here means a `TopicSubscriber`, `MessageConsumer` or `JMSConsumer` object in any client.

      An unshared durable subscription is identified by a name specified by the client and by the client identifier, which must be set. An application which subsequently wishes to create a consumer on that unshared durable subscription must use the same client identifier.

      If an unshared durable subscription already exists with the same name and client identifier, and the same topic, message selector and `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this method creates a `TopicSubscriber` on the existing durable subscription.

      If an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active (i.e. not closed) on the durable subscription, then a `JMSException` will be thrown.

      If an unshared durable subscription already exists with the same name and client identifier but a different topic, message selector or `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this is equivalent to unsubscribing (deleting) the old one and creating a new one.

      If `noLocal` is set to true then any messages published to the topic using this session's connection, or any other connection with the same client identifier, will not be added to the durable subscription.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier. If a shared durable subscription already exists with the same name and client identifier then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId. Such subscriptions would be completely separate.

      This method is identical to the corresponding `createDurableConsumer` method except that it returns a `TopicSubscriber` rather than a `MessageConsumer` to represent the consumer.

      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
        `messageSelector` - only messages with properties matching the message selector expression are added to the durable subscription. A value of null or an empty string indicates that there is no message selector for the durable subscription.
        `noLocal` - if true then any messages published to the topic using this session's connection, or any other connection with the same client identifier, will not be added to the durable subscription.
      Throws:
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.
        `IllegalStateException` - if the client identifier is unset
        `JMSException` -
        - if the session fails to create the unshared durable subscription and `TopicSubscriber` due to some internal error
        - if an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active
        - if a shared durable subscription already exists with the same name and client identifier
      Since:
        JMS 1.1

    - #### createDurableConsumer

          MessageConsumer createDurableConsumer(Topic topic,
                                                java.lang.String name)
                                         throws JMSException

      Creates an unshared durable subscription on the specified topic (if one does not already exist) and creates a consumer on that durable subscription. This method creates the durable subscription without a message selector and with a `noLocal` value of `false`.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with unshared durable subscriptions. Any durable subscription created using this method will be unshared. This means that only one active (i.e. not closed) consumer on the subscription may exist at a time. The term "consumer" here means a `TopicSubscriber`, `MessageConsumer` or `JMSConsumer` object in any client.

      An unshared durable subscription is identified by a name specified by the client and by the client identifier, which must be set. An application which subsequently wishes to create a consumer on that unshared durable subscription must use the same client identifier.

      If an unshared durable subscription already exists with the same name and client identifier, and the same topic, message selector and `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this method creates a `MessageConsumer` on the existing durable subscription.

      If an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active (i.e. not closed) on the durable subscription, then a `JMSException` will be thrown.

      If an unshared durable subscription already exists with the same name and client identifier but a different topic, message selector or `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this is equivalent to unsubscribing (deleting) the old one and creating a new one.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier. If a shared durable subscription already exists with the same name and client identifier then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId. Such subscriptions would be completely separate.

      This method is identical to the corresponding `createDurableSubscriber` method except that it returns a `MessageConsumer` rather than a `TopicSubscriber` to represent the consumer.

      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
      Throws:
        `InvalidDestinationException` - if an invalid topic is specified.
        `IllegalStateException` - if the client identifier is unset
        `JMSException` -
        - if the session fails to create the unshared durable subscription and `MessageConsumer` due to some internal error
        - if an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active
        - if a shared durable subscription already exists with the same name and client identifier
      Since:
        JMS 2.0

    - #### createDurableConsumer

          MessageConsumer createDurableConsumer(Topic topic,
                                                java.lang.String name,
                                                java.lang.String messageSelector,
                                                boolean noLocal)
                                         throws JMSException

      Creates an unshared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with unshared durable subscriptions. Any durable subscription created using this method will be unshared. This means that only one active (i.e. not closed) consumer on the subscription may exist at a time. The term "consumer" here means a `TopicSubscriber`, `MessageConsumer` or `JMSConsumer` object in any client.

      An unshared durable subscription is identified by a name specified by the client and by the client identifier, which must be set. An application which subsequently wishes to create a consumer on that unshared durable subscription must use the same client identifier.

      If an unshared durable subscription already exists with the same name and client identifier, and the same topic, message selector and `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this method creates a `MessageConsumer` on the existing durable subscription.

      If an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active (i.e. not closed) on the durable subscription, then a `JMSException` will be thrown.

      If an unshared durable subscription already exists with the same name and client identifier but a different topic, message selector or `noLocal` value has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this is equivalent to unsubscribing (deleting) the old one and creating a new one.

      If `noLocal` is set to true then any messages published to the topic using this session's connection, or any other connection with the same client identifier, will not be added to the durable subscription.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier. If a shared durable subscription already exists with the same name and client identifier then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId. Such subscriptions would be completely separate.

      This method is identical to the corresponding `createDurableSubscriber` method except that it returns a `MessageConsumer` rather than a `TopicSubscriber` to represent the consumer.

      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
        `messageSelector` - only messages with properties matching the message selector expression are added to the durable subscription. A value of null or an empty string indicates that there is no message selector for the durable subscription.
        `noLocal` - if true then any messages published to the topic using this session's connection, or any other connection with the same client identifier, will not be added to the durable subscription.
      Throws:
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.
        `IllegalStateException` - if the client identifier is unset
        `JMSException` -
        - if the session fails to create the unshared durable subscription and `MessageConsumer` due to some internal error
        - if an unshared durable subscription already exists with the same name and client identifier, and there is a consumer already active
        - if a shared durable subscription already exists with the same name and client identifier
      Since:
        JMS 2.0

    - #### createSharedDurableConsumer

          MessageConsumer createSharedDurableConsumer(Topic topic,
                                                      java.lang.String name)
                                               throws JMSException

      Creates a shared durable subscription on the specified topic (if one does not already exist), specifying a message selector and the `noLocal` parameter, and creates a consumer on that durable subscription. This method creates the durable subscription without a message selector.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with shared durable subscriptions. Any durable subscription created using this method will be shared. This means that multiple active (i.e. not closed) consumers on the subscription may exist at the same time. The term "consumer" here means a `MessageConsumer` or `JMSConsumer` object in any client.

      A shared durable subscription is identified by a name specified by the client and by the client identifier (which may be unset). An application which subsequently wishes to create a consumer on that shared durable subscription must use the same client identifier.

      If a shared durable subscription already exists with the same name and client identifier (if set), and the same topic and message selector has been specified, then this method creates a `MessageConsumer` on the existing shared durable subscription.

      If a shared durable subscription already exists with the same name and client identifier (if set) but a different topic or message selector has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this is equivalent to unsubscribing (deleting) the old one and creating a new one.

      If a shared durable subscription already exists with the same name and client identifier (if set) but a different topic or message selector has been specified, and there is a consumer already active (i.e. not closed) on the durable subscription, then a `JMSException` will be thrown.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier (if set). If an unshared durable subscription already exists with the same name and client identifier (if set) then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId (which may be unset). Such subscriptions would be completely separate.

      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
      Throws:
        `JMSException` -
        - if the session fails to create the shared durable subscription and `MessageConsumer` due to some internal error
        - if a shared durable subscription already exists with the same name and client identifier, but a different topic or message selector, and there is a consumer already active
        - if an unshared durable subscription already exists with the same name and client identifier
        `InvalidDestinationException` - if an invalid topic is specified.
      Since:
        JMS 2.0

    - #### createSharedDurableConsumer

          MessageConsumer createSharedDurableConsumer(Topic topic,
                                                      java.lang.String name,
                                                      java.lang.String messageSelector)
                                               throws JMSException

      Creates a shared durable subscription on the specified topic (if one does not already exist), specifying a message selector, and creates a consumer on that durable subscription.

      A durable subscription is used by an application which needs to receive all the messages published on a topic, including the ones published when there is no active consumer associated with it. The JMS provider retains a record of this durable subscription and ensures that all messages from the topic's publishers are retained until they are delivered to, and acknowledged by, a consumer on this durable subscription or until they have expired.

      A durable subscription will continue to accumulate messages until it is deleted using the `unsubscribe` method.

      This method may only be used with shared durable subscriptions. Any durable subscription created using this method will be shared. This means that multiple active (i.e. not closed) consumers on the subscription may exist at the same time. The term "consumer" here means a `MessageConsumer` or `JMSConsumer` object in any client.

      A shared durable subscription is identified by a name specified by the client and by the client identifier (which may be unset). An application which subsequently wishes to create a consumer on that shared durable subscription must use the same client identifier.

      If a shared durable subscription already exists with the same name and client identifier (if set), and the same topic and message selector has been specified, then this method creates a `MessageConsumer` on the existing shared durable subscription.

      If a shared durable subscription already exists with the same name and client identifier (if set) but a different topic or message selector has been specified, and there is no consumer already active (i.e. not closed) on the durable subscription then this is equivalent to unsubscribing (deleting) the old one and creating a new one.

      If a shared durable subscription already exists with the same name and client identifier (if set) but a different topic or message selector has been specified, and there is a consumer already active (i.e. not closed) on the durable subscription, then a `JMSException` will be thrown.

      A shared durable subscription and an unshared durable subscription may not have the same name and client identifier (if set). If an unshared durable subscription already exists with the same name and client identifier (if set) then a `JMSException` is thrown.

      There is no restriction on durable subscriptions and shared non-durable subscriptions having the same name and clientId (which may be unset). Such subscriptions would be completely separate.

      Parameters:
        `topic` - the non-temporary `Topic` to subscribe to
        `name` - the name used to identify this subscription
        `messageSelector` - only messages with properties matching the message selector expression are added to the durable subscription. A value of null or an empty string indicates that there is no message selector for the durable subscription.
      Throws:
        `JMSException` -
        - if the session fails to create the shared durable subscription and `MessageConsumer` due to some internal error
        - if a shared durable subscription already exists with the same name and client identifier, but a different topic or message selector, and there is a consumer already active
        - if an unshared durable subscription already exists with the same name and client identifier
        `InvalidDestinationException` - if an invalid topic is specified.
        `InvalidSelectorException` - if the message selector is invalid.
      Since:
        JMS 2.0

    - #### createBrowser

          QueueBrowser createBrowser(Queue queue)
                              throws JMSException

      Creates a `QueueBrowser` object to peek at the messages on the specified queue.
      Parameters:
        `queue` - the `queue` to access
      Throws:
        `JMSException` - if the session fails to create a browser due to some internal error.
        `InvalidDestinationException` - if an invalid destination is specified
      Since:
        JMS 1.1

    - #### createBrowser

          QueueBrowser createBrowser(Queue queue,
                                     java.lang.String messageSelector)
                              throws JMSException

      Creates a `QueueBrowser` object to peek at the messages on the specified queue using a message selector.
      Parameters:
        `queue` - the `queue` to access
        `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
      Throws:
        `JMSException` - if the session fails to create a browser due to some internal error.
        `InvalidDestinationException` - if an invalid destination is specified
        `InvalidSelectorException` - if the message selector is invalid.
      Since:
        JMS 1.1

    - #### createTemporaryQueue

          TemporaryQueue createTemporaryQueue()
                                       throws JMSException

      Creates a `TemporaryQueue` object. Its lifetime will be that of the `Connection` unless it is deleted earlier.
      Returns:
        a temporary queue identity
      Throws:
        `JMSException` - if the session fails to create a temporary queue due to some internal error.
      Since:
        JMS 1.1

    - #### createTemporaryTopic

          TemporaryTopic createTemporaryTopic()
                                       throws JMSException

      Creates a `TemporaryTopic` object. Its lifetime will be that of the `Connection` unless it is deleted earlier.
      Returns:
        a temporary topic identity
      Throws:
        `JMSException` - if the session fails to create a temporary topic due to some internal error.
      Since:
        JMS 1.1

    - #### unsubscribe

          void unsubscribe(java.lang.String name)
                    throws JMSException

      Unsubscribes a durable subscription that has been created by a client.

      This method deletes the state being maintained on behalf of the subscriber by its provider.

      A durable subscription is identified by a name specified by the client and by the client identifier if set. If the client identifier was set when the durable subscription was created then a client which subsequently wishes to use this method to delete a durable subscription must use the same client identifier.

      It is erroneous for a client to delete a durable subscription while there is an active (not closed) consumer for the subscription, or while a consumed message is part of a pending transaction or has not been acknowledged in the session.

      Parameters:
        `name` - the name used to identify this subscription
      Throws:
        `JMSException` - if the session fails to unsubscribe to the durable subscription due to some internal error.
        `InvalidDestinationException` - if an invalid subscription name is specified.
      Since:
        JMS 1.1